# TIC-TAC-TOE-GUI-mit-Sizer.py

#----------------------------------------------------------------------

import  wx
import TicTacToe

#----------------------------------------------------------------------

class TTTPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent, -1,
                         style=wx.NO_FULL_REPAINT_ON_RESIZE)

        self.parentWindow = parent
        self.tTT = TicTacToe.TTT()
        gif = wx.Bitmap("ttt-weiss.gif", wx.BITMAP_TYPE_GIF)
        self.gifb = wx.Bitmap("ttt-blau.gif", wx.BITMAP_TYPE_GIF)
        self.gifr = wx.Bitmap("ttt-rot.gif", wx.BITMAP_TYPE_GIF)
        self.buttons=[]

        sizer = wx.GridSizer(3, vgap = 20, hgap = 20)
        self.b1 = wx.BitmapButton(self, 1, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b1)
        self.buttons.append(self.b1)
        sizer.Add(self.b1, flag = wx.ALIGN_CENTER, border = 10)

        self.b2 = wx.BitmapButton(self, 2, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b2)
        self.buttons.append(self.b2)
        sizer.Add(self.b2, flag = wx.ALIGN_CENTER, border = 10)

        self.b3 = wx.BitmapButton(self, 3, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b3)
        self.buttons.append(self.b3)
        sizer.Add(self.b3, flag = wx.ALIGN_CENTER, border = 10)

        self.b4 = wx.BitmapButton(self, 4, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b4)
        self.buttons.append(self.b4)
        sizer.Add(self.b4, flag = wx.ALIGN_CENTER, border = 10)

        self.b5 = wx.BitmapButton(self, 5, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b5)
        self.buttons.append(self.b5)
        sizer.Add(self.b5, flag = wx.ALIGN_CENTER, border = 10)

        self.b6 = wx.BitmapButton(self, 6, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b6)
        self.buttons.append(self.b6)
        sizer.Add(self.b6, flag = wx.ALIGN_CENTER, border = 10)

        self.b7 = wx.BitmapButton(self, 7, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b7)
        self.buttons.append(self.b7)
        sizer.Add(self.b7, flag = wx.ALIGN_CENTER, border = 10)

        self.b8 = wx.BitmapButton(self, 8, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b8)
        self.buttons.append(self.b8)
        sizer.Add(self.b8, 0, flag = wx.ALIGN_CENTER, border = 10)

        self.b9 = wx.BitmapButton(self, 9, gif, size =  (gif.GetWidth()+10, gif.GetHeight()+10))
        self.Bind(wx.EVT_BUTTON, self.OnClick, self.b9)
        self.buttons.append(self.b9)
        sizer.Add(self.b9, 0, flag = wx.ALIGN_CENTER, border = 10)

        self.SetSizer(sizer)
        self.Layout()

    def OnClick(self, event):
        if self.tTT.Setze(event.GetId()):
            inhalt=self.tTT.ZeigeInhalt(event.GetId())
            if inhalt=='r':
                self.buttons[event.GetId()-1].SetBitmapLabel(self.gifr)
            elif inhalt=='b':
                self.buttons[event.GetId()-1].SetBitmapLabel(self.gifb)
            gewonnen = self.tTT.Gewonnen()
            if gewonnen[0]:
                text = ''
                if gewonnen[1]=='r':
                    text = "Spieler ROT hat gewonnen"
                else:
                    text = "Spieler BLAU hat gewonnen"
                dlg = wx.MessageDialog(self, text,
                               'Spiel beendet!',
                               wx.OK | wx.ICON_INFORMATION
                               #wx.YES_NO | wx.NO_DEFAULT | wx.CANCEL | wx.ICON_INFORMATION
                               )
                dlg.ShowModal()
                dlg.Destroy()
                self.parentWindow.Close(True)
                

        

class Fenster(wx.Frame):
    """
    Die Klasse Fenster erzeugt einen Frame.
    """
    def __init__(self, parent, title):
        wx.Frame.__init__(self, parent, -1, title,
                          pos=(100, 100), size=(260, 300))
        self.panel = TTTPanel(self)

class MyApp(wx.App):
    def OnInit(self):
        frame = Fenster(None, "tic tac toe")
        self.SetTopWindow(frame)
        frame.Show(True)
        return True
        
app = MyApp(redirect=False)
# Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
app.MainLoop()
# Anwendung und pythonwin beenden mit:
# exit()
